var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var src_exports = {};
__export(src_exports, {
  default: () => src_default
});
module.exports = __toCommonJS(src_exports);
var import_micromatch = __toESM(require("micromatch"), 1);
var import_fs_extra = require("fs-extra");
var import_fast_glob = __toESM(require("fast-glob"), 1);
var import_picocolors = __toESM(require("picocolors"), 1);
var import_path = require("path");
const ViteHmrPublicCopy = (config = { copy: true, copyAtStart: true }) => {
  let viteConfig, paths = [], currentDir = (0, import_path.resolve)();
  const copyMatchedFiles = (files) => {
    if (files.length > 0) {
      for (let i = 0, il = files.length; i < il; ++i) {
        let outDestination = files[i].replace(viteConfig.publicDir, (0, import_path.resolve)(currentDir, viteConfig.build.outDir));
        viteConfig.logger.info(
          import_picocolors.default.green("[ViteHmrPublicCopy] ") + import_picocolors.default.dim("copying ") + import_picocolors.default.blue((0, import_path.relative)(currentDir, files[i])) + import_picocolors.default.dim(" to ") + import_picocolors.default.blue((0, import_path.relative)(currentDir, outDestination))
        );
        (0, import_fs_extra.copy)(files[i], outDestination).catch((err) => {
          viteConfig.logger.error(import_picocolors.default.red(`The file "${files[i]}" could not be copied`));
          viteConfig.logger.error(err);
        });
      }
    }
  };
  return {
    name: "ViteHmrPublicCopy",
    configResolved(resolvedConfig) {
      viteConfig = resolvedConfig;
      if (config.copy.constructor === Array) {
        paths.concat(config.copy);
      } else if (config.copy) {
        paths.push(`${viteConfig.publicDir}/**/*`);
      }
    },
    async handleHotUpdate({ file }) {
      let matchedFiles = (0, import_micromatch.default)(file, paths);
      copyMatchedFiles(matchedFiles);
    },
    async buildStart() {
      if (config.copyAtStart) {
        let allFiles = await (0, import_fast_glob.default)(`${viteConfig.publicDir}/**/*`);
        let matchedFiles = (0, import_micromatch.default)(allFiles, paths);
        copyMatchedFiles(matchedFiles);
      }
    }
  };
};
var src_default = ViteHmrPublicCopy;
